import java.util.Properties;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.MessageProducer;
import javax.jms.Queue;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.transaction.TransactionManager;

public class RemoteJtaTester {

	/**
	 * @param args
	 * @throws Exception
	 */
	public static void main(String[] args) throws Exception {
		try {
			Properties props = new Properties();
			props.put("java.naming.factory.initial", "com.sun.enterprise.naming.SerialInitContextFactory");
			props.put("java.naming.factory.url.pkgs", "com.sun.enterprise.naming");
			props.put("java.naming.factory.state", "com.sun.corba.ee.impl.presentation.rmi.JNDIStateFactoryImpl");
			//props.put(Context.PROVIDER_URL, "iiop://localhost:3700");
			props.put("org.omg.CORBA.ORBInitialHost", "127.0.0.1");
			props.put("org.omg.CORBA.ORBInitialPort", "3700");

			Context ctx = new InitialContext(props);

			ConnectionFactory cf = (ConnectionFactory) ctx.lookup("jms/exampleXaCF");
			Queue q = (Queue)ctx.lookup("jms/exampleQueue");
			TransactionManager tm = (TransactionManager) ctx.lookup("java:appserver/TransactionManager");
			Connection c = cf.createConnection();
			tm.begin();
			Session s = c.createSession(true, Session.AUTO_ACKNOWLEDGE); //TODO check the correct ack mode
			MessageProducer p = s.createProducer(q);
			TextMessage m = s.createTextMessage();
			m.setText("This is a test msg");
			p.send(m);
			// s.close();
			// c.close();
			tm.commit(); // <--- NPE Here!!!
			System.out.println("OK");
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
